// Autogenerated from Pigeon (v17.1.3), do not edit directly.
// See also: https://pub.dev/packages/pigeon

package com.aidlab.aidlab_sdk

import android.util.Log
import io.flutter.plugin.common.BasicMessageChannel
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MessageCodec
import io.flutter.plugin.common.StandardMessageCodec
import java.io.ByteArrayOutputStream
import java.nio.ByteBuffer

private fun wrapResult(result: Any?): List<Any?> {
  return listOf(result)
}

private fun wrapError(exception: Throwable): List<Any?> {
  if (exception is FlutterError) {
    return listOf(
      exception.code,
      exception.message,
      exception.details
    )
  } else {
    return listOf(
      exception.javaClass.simpleName,
      exception.toString(),
      "Cause: " + exception.cause + ", Stacktrace: " + Log.getStackTraceString(exception)
    )
  }
}

private fun createConnectionError(channelName: String): FlutterError {
  return FlutterError("channel-error",  "Unable to establish connection on channel: '$channelName'.", "")}

/**
 * Error class for passing custom error details to Flutter via a thrown PlatformException.
 * @property code The error code.
 * @property message The error message.
 * @property details The error details. Must be a datatype supported by the api codec.
 */
class FlutterError (
  val code: String,
  override val message: String? = null,
  val details: Any? = null
) : Throwable()

enum class SyncState_(val raw: Int) {
  START(0),
  END(1),
  STOP(2),
  EMPTY(3);

  companion object {
    fun ofRaw(raw: Int): SyncState_? {
      return values().firstOrNull { it.raw == raw }
    }
  }
}

enum class WearState_(val raw: Int) {
  PLACED_PROPERLY(0),
  PLACED_UPSIDE_DOWN(1),
  LOOSE(2),
  DETACHED(3),
  UNKNOWN(4);

  companion object {
    fun ofRaw(raw: Int): WearState_? {
      return values().firstOrNull { it.raw == raw }
    }
  }
}

enum class EcgFiltrationMethod_(val raw: Int) {
  NORMAL(0),
  AGGRESSIVE(1);

  companion object {
    fun ofRaw(raw: Int): EcgFiltrationMethod_? {
      return values().firstOrNull { it.raw == raw }
    }
  }
}

enum class DisconnectReason_(val raw: Int) {
  TIMEOUT(0),
  DEVICE_DISCONNECTED(1),
  APP_DISCONNECTED(2),
  SDK_OUTDATED(3),
  UNKNOWN_ERROR(4);

  companion object {
    fun ofRaw(raw: Int): DisconnectReason_? {
      return values().firstOrNull { it.raw == raw }
    }
  }
}

enum class DataType_(val raw: Int) {
  ECG(0),
  RESPIRATION(1),
  SKIN_TEMPERATURE(2),
  MOTION(3),
  RESERVED_0(4),
  ACTIVITY(5),
  ORIENTATION(6),
  STEPS(7),
  HEART_RATE(8),
  RESERVED_1(9),
  SOUND_VOLUME(10),
  RR(11),
  PRESSURE(12),
  SOUND_FEATURES(13),
  RESPIRATION_RATE(14),
  BODY_POSITION(15);

  companion object {
    fun ofRaw(raw: Int): DataType_? {
      return values().firstOrNull { it.raw == raw }
    }
  }
}

enum class ScanMode_(val raw: Int) {
  LOW_POWER(0),
  AGGRESSIVE(1);

  companion object {
    fun ofRaw(raw: Int): ScanMode_? {
      return values().firstOrNull { it.raw == raw }
    }
  }
}

enum class BodyPosition_(val raw: Int) {
  UNDEFINED(0),
  PRONE(1),
  SUPINE(2),
  LEFT_SIDE(3),
  RIGHT_SIDE(4);

  companion object {
    fun ofRaw(raw: Int): BodyPosition_? {
      return values().firstOrNull { it.raw == raw }
    }
  }
}

enum class Exercise_(val raw: Int) {
  PUSH_UP(0),
  JUMP(1),
  SIT_UP(2),
  BURPEE(3),
  PULL_UP(4),
  SQUAT(5),
  PLANK_START(6),
  PLANK_END(7);

  companion object {
    fun ofRaw(raw: Int): Exercise_? {
      return values().firstOrNull { it.raw == raw }
    }
  }
}

enum class ActivityType_(val raw: Int) {
  UNSPECIFIC(0),
  AUTOMOTIVE(1),
  WALKING(2),
  RUNNING(3),
  CYCLING(4),
  STILL(5);

  companion object {
    fun ofRaw(raw: Int): ActivityType_? {
      return values().firstOrNull { it.raw == raw }
    }
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class FlutterDataType_ (
  val signal: DataType_? = null

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): FlutterDataType_ {
      val signal: DataType_? = (list[0] as Int?)?.let {
        DataType_.ofRaw(it)
      }
      return FlutterDataType_(signal)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      signal?.raw,
    )
  }
}

/** Generated class from Pigeon that represents data sent in messages. */
data class Device_ (
  val firmwareRevision: String? = null,
  val hardwareRevision: String? = null,
  val serialNumber: String? = null,
  val name: String? = null,
  val manufacturerName: String? = null,
  val address: String

) {
  companion object {
    @Suppress("UNCHECKED_CAST")
    fun fromList(list: List<Any?>): Device_ {
      val firmwareRevision = list[0] as String?
      val hardwareRevision = list[1] as String?
      val serialNumber = list[2] as String?
      val name = list[3] as String?
      val manufacturerName = list[4] as String?
      val address = list[5] as String
      return Device_(firmwareRevision, hardwareRevision, serialNumber, name, manufacturerName, address)
    }
  }
  fun toList(): List<Any?> {
    return listOf<Any?>(
      firmwareRevision,
      hardwareRevision,
      serialNumber,
      name,
      manufacturerName,
      address,
    )
  }
}
@Suppress("UNCHECKED_CAST")
private object AidlabManager_Codec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          Device_.fromList(it)
        }
      }
      129.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          FlutterDataType_.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is Device_ -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      is FlutterDataType_ -> {
        stream.write(129)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated interface from Pigeon that represents a handler of messages from Flutter. */
interface AidlabManager_ {
  fun scan(mode: ScanMode_)
  fun stopScan()
  fun connect(device: Device_)
  fun collect(device: Device_, dataTypes: List<FlutterDataType_>, dataTypesToStore: List<FlutterDataType_>)
  fun disconnect(device: Device_)

  companion object {
    /** The codec used by AidlabManager_. */
    val codec: MessageCodec<Any?> by lazy {
      AidlabManager_Codec
    }
    /** Sets up an instance of `AidlabManager_` to handle messages through the `binaryMessenger`. */
    @Suppress("UNCHECKED_CAST")
    fun setUp(binaryMessenger: BinaryMessenger, api: AidlabManager_?) {
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.AidlabManager_.scan", codec)
        if (api != null) {
          channel.setMessageHandler { message, reply ->
            val args = message as List<Any?>
            val modeArg = ScanMode_.ofRaw(args[0] as Int)!!
            var wrapped: List<Any?>
            try {
              api.scan(modeArg)
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.AidlabManager_.stopScan", codec)
        if (api != null) {
          channel.setMessageHandler { _, reply ->
            var wrapped: List<Any?>
            try {
              api.stopScan()
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.AidlabManager_.connect", codec)
        if (api != null) {
          channel.setMessageHandler { message, reply ->
            val args = message as List<Any?>
            val deviceArg = args[0] as Device_
            var wrapped: List<Any?>
            try {
              api.connect(deviceArg)
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.AidlabManager_.collect", codec)
        if (api != null) {
          channel.setMessageHandler { message, reply ->
            val args = message as List<Any?>
            val deviceArg = args[0] as Device_
            val dataTypesArg = args[1] as List<FlutterDataType_>
            val dataTypesToStoreArg = args[2] as List<FlutterDataType_>
            var wrapped: List<Any?>
            try {
              api.collect(deviceArg, dataTypesArg, dataTypesToStoreArg)
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
      run {
        val channel = BasicMessageChannel<Any?>(binaryMessenger, "dev.flutter.pigeon.aidlab_sdk.AidlabManager_.disconnect", codec)
        if (api != null) {
          channel.setMessageHandler { message, reply ->
            val args = message as List<Any?>
            val deviceArg = args[0] as Device_
            var wrapped: List<Any?>
            try {
              api.disconnect(deviceArg)
              wrapped = listOf<Any?>(null)
            } catch (exception: Throwable) {
              wrapped = wrapError(exception)
            }
            reply.reply(wrapped)
          }
        } else {
          channel.setMessageHandler(null)
        }
      }
    }
  }
}
@Suppress("UNCHECKED_CAST")
private object AidlabManagerDelegate_Codec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          Device_.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is Device_ -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated class from Pigeon that represents Flutter messages that can be called from Kotlin. */
@Suppress("UNCHECKED_CAST")
class AidlabManagerDelegate_(private val binaryMessenger: BinaryMessenger) {
  companion object {
    /** The codec used by AidlabManagerDelegate_. */
    val codec: MessageCodec<Any?> by lazy {
      AidlabManagerDelegate_Codec
    }
  }
  fun onBluetoothStarted(callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onBluetoothStarted"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(null) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun onDeviceScanStarted(callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onDeviceScanStarted"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(null) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun onDeviceScanStopped(callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onDeviceScanStopped"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(null) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun onScanFailed(errorCodeArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onScanFailed"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(errorCodeArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didDiscover(deviceArg: Device_, rssiArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.didDiscover"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, rssiArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
}
@Suppress("UNCHECKED_CAST")
private object DeviceDelegate_Codec : StandardMessageCodec() {
  override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
    return when (type) {
      128.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          Device_.fromList(it)
        }
      }
      129.toByte() -> {
        return (readValue(buffer) as? List<Any?>)?.let {
          Device_.fromList(it)
        }
      }
      else -> super.readValueOfType(type, buffer)
    }
  }
  override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
    when (value) {
      is Device_ -> {
        stream.write(128)
        writeValue(stream, value.toList())
      }
      is Device_ -> {
        stream.write(129)
        writeValue(stream, value.toList())
      }
      else -> super.writeValue(stream, value)
    }
  }
}

/** Generated class from Pigeon that represents Flutter messages that can be called from Kotlin. */
@Suppress("UNCHECKED_CAST")
class DeviceDelegate_(private val binaryMessenger: BinaryMessenger) {
  companion object {
    /** The codec used by DeviceDelegate_. */
    val codec: MessageCodec<Any?> by lazy {
      DeviceDelegate_Codec
    }
  }
  fun didConnect(deviceArg: Device_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didConnect"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didDisconnect(deviceArg: Device_?, reasonArg: DisconnectReason_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDisconnect"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, reasonArg.raw)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun wearStateDidChange(deviceArg: Device_, wearStateArg: WearState_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.wearStateDidChange"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, wearStateArg.raw)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveECG(deviceArg: Device_, timestampArg: Long, valueArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveECG"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveRespiration(deviceArg: Device_, timestampArg: Long, valueArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespiration"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveRespirationRate(deviceArg: Device_, timestampArg: Long, valueArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespirationRate"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveBatteryLevel(deviceArg: Device_, stateOfChargeArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBatteryLevel"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, stateOfChargeArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveSkinTemperature(deviceArg: Device_, timestampArg: Long, valueArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSkinTemperature"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveAccelerometer(deviceArg: Device_, timestampArg: Long, axArg: Double, ayArg: Double, azArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveAccelerometer"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, axArg, ayArg, azArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveGyroscope(deviceArg: Device_, timestampArg: Long, qxArg: Double, qyArg: Double, qzArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveGyroscope"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, qxArg, qyArg, qzArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveMagnetometer(deviceArg: Device_, timestampArg: Long, mxArg: Double, myArg: Double, mzArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMagnetometer"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, mxArg, myArg, mzArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveQuaternion(deviceArg: Device_, timestampArg: Long, qwArg: Double, qxArg: Double, qyArg: Double, qzArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveQuaternion"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, qwArg, qxArg, qyArg, qzArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveOrientation(deviceArg: Device_, timestampArg: Long, rollArg: Double, pitchArg: Double, yawArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveOrientation"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, rollArg, pitchArg, yawArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveBodyPosition(deviceArg: Device_, timestampArg: Long, bodyPositionArg: BodyPosition_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBodyPosition"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, bodyPositionArg.raw)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveActivity(deviceArg: Device_, timestampArg: Long, activityArg: ActivityType_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveActivity"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, activityArg.raw)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveSteps(deviceArg: Device_, timestampArg: Long, stepsArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSteps"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, stepsArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveHeartRate(deviceArg: Device_, timestampArg: Long, heartRateArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveHeartRate"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, heartRateArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveRr(deviceArg: Device_, timestampArg: Long, rrArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRr"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, rrArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didDetectExercise(deviceArg: Device_, exerciseArg: Exercise_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectExercise"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, exerciseArg.raw)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveSoundVolume(deviceArg: Device_, timestampArg: Long, valueArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundVolume"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveSoundFeatures(deviceArg: Device_, timestampArg: Long, valuesArg: List<Double>, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundFeatures"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valuesArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePressure(deviceArg: Device_, timestampArg: Long, valueArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePressure"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun pressureWearStateDidChange(deviceArg: Device_, wearStateArg: WearState_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.pressureWearStateDidChange"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, wearStateArg.raw)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveSignalQuality(deviceArg: Device_, timestampArg: Long, valueArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSignalQuality"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didDetectUserEvent(deviceArg: Device_, timestampArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectUserEvent"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveCommand(deviceArg: Device_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveCommand"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveError(errorArg: String, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveError"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(errorArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveMessage(deviceArg: Device_, processArg: String, messageArg: String, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMessage"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, processArg, messageArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun syncStateDidChange(deviceArg: Device_, stateArg: SyncState_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.syncStateDidChange"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, stateArg.raw)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceiveUnsynchronizedSize(deviceArg: Device_, unsynchronizedSizeArg: Long, syncBytesPerSecondArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveUnsynchronizedSize"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, unsynchronizedSizeArg, syncBytesPerSecondArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastECG(deviceArg: Device_, timestampArg: Long, valueArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastECG"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastRespiration(deviceArg: Device_, timestampArg: Long, valueArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespiration"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastSkinTemperature(deviceArg: Device_, timestampArg: Long, valueArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSkinTemperature"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastHeartRate(deviceArg: Device_, timestampArg: Long, heartRateArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastHeartRate"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, heartRateArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastRr(deviceArg: Device_, timestampArg: Long, rrArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRr"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, rrArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastRespirationRate(deviceArg: Device_, timestampArg: Long, valueArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespirationRate"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastActivity(deviceArg: Device_, timestampArg: Long, activityArg: ActivityType_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastActivity"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, activityArg.raw)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastSteps(deviceArg: Device_, timestampArg: Long, valueArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSteps"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastSoundVolume(deviceArg: Device_, timestampArg: Long, soundVolumeArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundVolume"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, soundVolumeArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastSoundFeatures(deviceArg: Device_, timestampArg: Long, valuesArg: List<Double>, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundFeatures"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valuesArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastAccelerometer(deviceArg: Device_, timestampArg: Long, axArg: Double, ayArg: Double, azArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastAccelerometer"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, axArg, ayArg, azArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastGyroscope(deviceArg: Device_, timestampArg: Long, qxArg: Double, qyArg: Double, qzArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastGyroscope"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, qxArg, qyArg, qzArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastMagnetometer(deviceArg: Device_, timestampArg: Long, mxArg: Double, myArg: Double, mzArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastMagnetometer"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, mxArg, myArg, mzArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastQuaternion(deviceArg: Device_, timestampArg: Long, qwArg: Double, qxArg: Double, qyArg: Double, qzArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastQuaternion"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, qwArg, qxArg, qyArg, qzArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastOrientation(deviceArg: Device_, timestampArg: Long, rollArg: Double, pitchArg: Double, yawArg: Double, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastOrientation"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, rollArg, pitchArg, yawArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastBodyPosition(deviceArg: Device_, timestampArg: Long, bodyPositionArg: BodyPosition_, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastBodyPosition"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, bodyPositionArg.raw)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastPressure(deviceArg: Device_, timestampArg: Long, valueArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastPressure"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didDetectPastUserEvent(deviceArg: Device_, timestampArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectPastUserEvent"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
  fun didReceivePastSignalQuality(deviceArg: Device_, timestampArg: Long, valueArg: Long, callback: (Result<Unit>) -> Unit)
{
    val channelName = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSignalQuality"
    val channel = BasicMessageChannel<Any?>(binaryMessenger, channelName, codec)
    channel.send(listOf(deviceArg, timestampArg, valueArg)) {
      if (it is List<*>) {
        if (it.size > 1) {
          callback(Result.failure(FlutterError(it[0] as String, it[1] as String, it[2] as String?)))
        } else {
          callback(Result.success(Unit))
        }
      } else {
        callback(Result.failure(createConnectionError(channelName)))
      } 
    }
  }
}
