// Autogenerated from Pigeon (v17.1.3), do not edit directly.
// See also: https://pub.dev/packages/pigeon

import Foundation

#if os(iOS)
  import Flutter
#elseif os(macOS)
  import FlutterMacOS
#else
  #error("Unsupported platform.")
#endif

private func wrapResult(_ result: Any?) -> [Any?] {
  return [result]
}

private func wrapError(_ error: Any) -> [Any?] {
  if let flutterError = error as? FlutterError {
    return [
      flutterError.code,
      flutterError.message,
      flutterError.details,
    ]
  }
  return [
    "\(error)",
    "\(type(of: error))",
    "Stacktrace: \(Thread.callStackSymbols)",
  ]
}

private func createConnectionError(withChannelName channelName: String) -> FlutterError {
  return FlutterError(code: "channel-error", message: "Unable to establish connection on channel: '\(channelName)'.", details: "")
}

private func isNullish(_ value: Any?) -> Bool {
  return value is NSNull || value == nil
}

private func nilOrValue<T>(_ value: Any?) -> T? {
  if value is NSNull { return nil }
  return value as! T?
}

enum SyncState_: Int {
  case start = 0
  case end = 1
  case stop = 2
  case empty = 3
}

enum WearState_: Int {
  case placedProperly = 0
  case placedUpsideDown = 1
  case loose = 2
  case detached = 3
  case unknown = 4
}

enum EcgFiltrationMethod_: Int {
  case normal = 0
  case aggressive = 1
}

enum DisconnectReason_: Int {
  case timeout = 0
  case deviceDisconnected = 1
  case appDisconnected = 2
  case sdkOutdated = 3
  case unknownError = 4
}

enum DataType_: Int {
  case eCG = 0
  case rESPIRATION = 1
  case sKINTEMPERATURE = 2
  case mOTION = 3
  case rESERVED0 = 4
  case aCTIVITY = 5
  case oRIENTATION = 6
  case sTEPS = 7
  case hEARTRATE = 8
  case rESERVED1 = 9
  case sOUNDVOLUME = 10
  case rR = 11
  case pRESSURE = 12
  case sOUNDFEATURES = 13
  case rESPIRATIONRATE = 14
  case bODYPOSITION = 15
}

enum ScanMode_: Int {
  case lowPower = 0
  case aggressive = 1
}

enum BodyPosition_: Int {
  case undefined = 0
  case prone = 1
  case supine = 2
  case leftSide = 3
  case rightSide = 4
}

enum Exercise_: Int {
  case pushUp = 0
  case jump = 1
  case sitUp = 2
  case burpee = 3
  case pullUp = 4
  case squat = 5
  case plankStart = 6
  case plankEnd = 7
}

enum ActivityType_: Int {
  case unspecific = 0
  case automotive = 1
  case walking = 2
  case running = 3
  case cycling = 4
  case still = 5
}

/// Generated class from Pigeon that represents data sent in messages.
struct FlutterDataType_ {
  var signal: DataType_? = nil

  static func fromList(_ list: [Any?]) -> FlutterDataType_? {
    var signal: DataType_? = nil
    let signalEnumVal: Int? = nilOrValue(list[0])
    if let signalRawValue = signalEnumVal {
      signal = DataType_(rawValue: signalRawValue)!
    }

    return FlutterDataType_(
      signal: signal
    )
  }
  func toList() -> [Any?] {
    return [
      signal?.rawValue
    ]
  }
}

/// Generated class from Pigeon that represents data sent in messages.
struct Device_ {
  var firmwareRevision: String? = nil
  var hardwareRevision: String? = nil
  var serialNumber: String? = nil
  var name: String? = nil
  var manufacturerName: String? = nil
  var address: String

  static func fromList(_ list: [Any?]) -> Device_? {
    let firmwareRevision: String? = nilOrValue(list[0])
    let hardwareRevision: String? = nilOrValue(list[1])
    let serialNumber: String? = nilOrValue(list[2])
    let name: String? = nilOrValue(list[3])
    let manufacturerName: String? = nilOrValue(list[4])
    let address = list[5] as! String

    return Device_(
      firmwareRevision: firmwareRevision,
      hardwareRevision: hardwareRevision,
      serialNumber: serialNumber,
      name: name,
      manufacturerName: manufacturerName,
      address: address
    )
  }
  func toList() -> [Any?] {
    return [
      firmwareRevision,
      hardwareRevision,
      serialNumber,
      name,
      manufacturerName,
      address,
    ]
  }
}
private class AidlabManager_CodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return Device_.fromList(self.readValue() as! [Any?])
    case 129:
      return FlutterDataType_.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class AidlabManager_CodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? Device_ {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? FlutterDataType_ {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class AidlabManager_CodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return AidlabManager_CodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return AidlabManager_CodecWriter(data: data)
  }
}

class AidlabManager_Codec: FlutterStandardMessageCodec {
  static let shared = AidlabManager_Codec(readerWriter: AidlabManager_CodecReaderWriter())
}

/// Generated protocol from Pigeon that represents a handler of messages from Flutter.
protocol AidlabManager_ {
  func scan(mode: ScanMode_) throws
  func stopScan() throws
  func connect(device: Device_) throws
  func collect(device: Device_, dataTypes: [FlutterDataType_], dataTypesToStore: [FlutterDataType_]) throws
  func disconnect(device: Device_) throws
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class AidlabManager_Setup {
  /// The codec used by AidlabManager_.
  static var codec: FlutterStandardMessageCodec { AidlabManager_Codec.shared }
  /// Sets up an instance of `AidlabManager_` to handle messages through the `binaryMessenger`.
  static func setUp(binaryMessenger: FlutterBinaryMessenger, api: AidlabManager_?) {
    let scanChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.AidlabManager_.scan", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      scanChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let modeArg = ScanMode_(rawValue: args[0] as! Int)!
        do {
          try api.scan(mode: modeArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      scanChannel.setMessageHandler(nil)
    }
    let stopScanChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.AidlabManager_.stopScan", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      stopScanChannel.setMessageHandler { _, reply in
        do {
          try api.stopScan()
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      stopScanChannel.setMessageHandler(nil)
    }
    let connectChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.AidlabManager_.connect", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      connectChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let deviceArg = args[0] as! Device_
        do {
          try api.connect(device: deviceArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      connectChannel.setMessageHandler(nil)
    }
    let collectChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.AidlabManager_.collect", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      collectChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let deviceArg = args[0] as! Device_
        let dataTypesArg = args[1] as! [FlutterDataType_]
        let dataTypesToStoreArg = args[2] as! [FlutterDataType_]
        do {
          try api.collect(device: deviceArg, dataTypes: dataTypesArg, dataTypesToStore: dataTypesToStoreArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      collectChannel.setMessageHandler(nil)
    }
    let disconnectChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.aidlab_sdk.AidlabManager_.disconnect", binaryMessenger: binaryMessenger, codec: codec)
    if let api = api {
      disconnectChannel.setMessageHandler { message, reply in
        let args = message as! [Any?]
        let deviceArg = args[0] as! Device_
        do {
          try api.disconnect(device: deviceArg)
          reply(wrapResult(nil))
        } catch {
          reply(wrapError(error))
        }
      }
    } else {
      disconnectChannel.setMessageHandler(nil)
    }
  }
}
private class AidlabManagerDelegate_CodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return Device_.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class AidlabManagerDelegate_CodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? Device_ {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class AidlabManagerDelegate_CodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return AidlabManagerDelegate_CodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return AidlabManagerDelegate_CodecWriter(data: data)
  }
}

class AidlabManagerDelegate_Codec: FlutterStandardMessageCodec {
  static let shared = AidlabManagerDelegate_Codec(readerWriter: AidlabManagerDelegate_CodecReaderWriter())
}

/// Generated protocol from Pigeon that represents Flutter messages that can be called from Swift.
protocol AidlabManagerDelegate_Protocol {
  func onBluetoothStarted(completion: @escaping (Result<Void, FlutterError>) -> Void)
  func onDeviceScanStarted(completion: @escaping (Result<Void, FlutterError>) -> Void)
  func onDeviceScanStopped(completion: @escaping (Result<Void, FlutterError>) -> Void)
  func onScanFailed(errorCode errorCodeArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didDiscover(device deviceArg: Device_, rssi rssiArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
}
class AidlabManagerDelegate_: AidlabManagerDelegate_Protocol {
  private let binaryMessenger: FlutterBinaryMessenger
  init(binaryMessenger: FlutterBinaryMessenger) {
    self.binaryMessenger = binaryMessenger
  }
  var codec: FlutterStandardMessageCodec {
    return AidlabManagerDelegate_Codec.shared
  }
  func onBluetoothStarted(completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onBluetoothStarted"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage(nil) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func onDeviceScanStarted(completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onDeviceScanStarted"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage(nil) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func onDeviceScanStopped(completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onDeviceScanStopped"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage(nil) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func onScanFailed(errorCode errorCodeArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onScanFailed"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([errorCodeArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didDiscover(device deviceArg: Device_, rssi rssiArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.didDiscover"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, rssiArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
}
private class DeviceDelegate_CodecReader: FlutterStandardReader {
  override func readValue(ofType type: UInt8) -> Any? {
    switch type {
    case 128:
      return Device_.fromList(self.readValue() as! [Any?])
    case 129:
      return Device_.fromList(self.readValue() as! [Any?])
    default:
      return super.readValue(ofType: type)
    }
  }
}

private class DeviceDelegate_CodecWriter: FlutterStandardWriter {
  override func writeValue(_ value: Any) {
    if let value = value as? Device_ {
      super.writeByte(128)
      super.writeValue(value.toList())
    } else if let value = value as? Device_ {
      super.writeByte(129)
      super.writeValue(value.toList())
    } else {
      super.writeValue(value)
    }
  }
}

private class DeviceDelegate_CodecReaderWriter: FlutterStandardReaderWriter {
  override func reader(with data: Data) -> FlutterStandardReader {
    return DeviceDelegate_CodecReader(data: data)
  }

  override func writer(with data: NSMutableData) -> FlutterStandardWriter {
    return DeviceDelegate_CodecWriter(data: data)
  }
}

class DeviceDelegate_Codec: FlutterStandardMessageCodec {
  static let shared = DeviceDelegate_Codec(readerWriter: DeviceDelegate_CodecReaderWriter())
}

/// Generated protocol from Pigeon that represents Flutter messages that can be called from Swift.
protocol DeviceDelegate_Protocol {
  func didConnect(device deviceArg: Device_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didDisconnect(device deviceArg: Device_?, reason reasonArg: DisconnectReason_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func wearStateDidChange(device deviceArg: Device_, wearState wearStateArg: WearState_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveECG(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveRespiration(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveRespirationRate(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveBatteryLevel(device deviceArg: Device_, stateOfCharge stateOfChargeArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveSkinTemperature(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveAccelerometer(device deviceArg: Device_, timestamp timestampArg: Int64, ax axArg: Double, ay ayArg: Double, az azArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveGyroscope(device deviceArg: Device_, timestamp timestampArg: Int64, qx qxArg: Double, qy qyArg: Double, qz qzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveMagnetometer(device deviceArg: Device_, timestamp timestampArg: Int64, mx mxArg: Double, my myArg: Double, mz mzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveQuaternion(device deviceArg: Device_, timestamp timestampArg: Int64, qw qwArg: Double, qx qxArg: Double, qy qyArg: Double, qz qzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveOrientation(device deviceArg: Device_, timestamp timestampArg: Int64, roll rollArg: Double, pitch pitchArg: Double, yaw yawArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveBodyPosition(device deviceArg: Device_, timestamp timestampArg: Int64, bodyPosition bodyPositionArg: BodyPosition_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveActivity(device deviceArg: Device_, timestamp timestampArg: Int64, activity activityArg: ActivityType_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveSteps(device deviceArg: Device_, timestamp timestampArg: Int64, steps stepsArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveHeartRate(device deviceArg: Device_, timestamp timestampArg: Int64, heartRate heartRateArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveRr(device deviceArg: Device_, timestamp timestampArg: Int64, rr rrArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didDetectExercise(device deviceArg: Device_, exercise exerciseArg: Exercise_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveSoundVolume(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveSoundFeatures(device deviceArg: Device_, timestamp timestampArg: Int64, values valuesArg: [Double], completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePressure(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func pressureWearStateDidChange(device deviceArg: Device_, wearState wearStateArg: WearState_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveSignalQuality(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didDetectUserEvent(device deviceArg: Device_, timestamp timestampArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveCommand(device deviceArg: Device_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveError(error errorArg: String, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveMessage(device deviceArg: Device_, process processArg: String, message messageArg: String, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func syncStateDidChange(device deviceArg: Device_, state stateArg: SyncState_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceiveUnsynchronizedSize(device deviceArg: Device_, unsynchronizedSize unsynchronizedSizeArg: Int64, syncBytesPerSecond syncBytesPerSecondArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastECG(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastRespiration(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastSkinTemperature(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastHeartRate(device deviceArg: Device_, timestamp timestampArg: Int64, heartRate heartRateArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastRr(device deviceArg: Device_, timestamp timestampArg: Int64, rr rrArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastRespirationRate(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastActivity(device deviceArg: Device_, timestamp timestampArg: Int64, activity activityArg: ActivityType_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastSteps(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastSoundVolume(device deviceArg: Device_, timestamp timestampArg: Int64, soundVolume soundVolumeArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastSoundFeatures(device deviceArg: Device_, timestamp timestampArg: Int64, values valuesArg: [Double], completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastAccelerometer(device deviceArg: Device_, timestamp timestampArg: Int64, ax axArg: Double, ay ayArg: Double, az azArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastGyroscope(device deviceArg: Device_, timestamp timestampArg: Int64, qx qxArg: Double, qy qyArg: Double, qz qzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastMagnetometer(device deviceArg: Device_, timestamp timestampArg: Int64, mx mxArg: Double, my myArg: Double, mz mzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastQuaternion(device deviceArg: Device_, timestamp timestampArg: Int64, qw qwArg: Double, qx qxArg: Double, qy qyArg: Double, qz qzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastOrientation(device deviceArg: Device_, timestamp timestampArg: Int64, roll rollArg: Double, pitch pitchArg: Double, yaw yawArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastBodyPosition(device deviceArg: Device_, timestamp timestampArg: Int64, bodyPosition bodyPositionArg: BodyPosition_, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastPressure(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didDetectPastUserEvent(device deviceArg: Device_, timestamp timestampArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
  func didReceivePastSignalQuality(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void)
}
class DeviceDelegate_: DeviceDelegate_Protocol {
  private let binaryMessenger: FlutterBinaryMessenger
  init(binaryMessenger: FlutterBinaryMessenger) {
    self.binaryMessenger = binaryMessenger
  }
  var codec: FlutterStandardMessageCodec {
    return DeviceDelegate_Codec.shared
  }
  func didConnect(device deviceArg: Device_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didConnect"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didDisconnect(device deviceArg: Device_?, reason reasonArg: DisconnectReason_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDisconnect"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, reasonArg.rawValue] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func wearStateDidChange(device deviceArg: Device_, wearState wearStateArg: WearState_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.wearStateDidChange"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, wearStateArg.rawValue] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveECG(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveECG"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveRespiration(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespiration"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveRespirationRate(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespirationRate"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveBatteryLevel(device deviceArg: Device_, stateOfCharge stateOfChargeArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBatteryLevel"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, stateOfChargeArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveSkinTemperature(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSkinTemperature"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveAccelerometer(device deviceArg: Device_, timestamp timestampArg: Int64, ax axArg: Double, ay ayArg: Double, az azArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveAccelerometer"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, axArg, ayArg, azArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveGyroscope(device deviceArg: Device_, timestamp timestampArg: Int64, qx qxArg: Double, qy qyArg: Double, qz qzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveGyroscope"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, qxArg, qyArg, qzArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveMagnetometer(device deviceArg: Device_, timestamp timestampArg: Int64, mx mxArg: Double, my myArg: Double, mz mzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMagnetometer"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, mxArg, myArg, mzArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveQuaternion(device deviceArg: Device_, timestamp timestampArg: Int64, qw qwArg: Double, qx qxArg: Double, qy qyArg: Double, qz qzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveQuaternion"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, qwArg, qxArg, qyArg, qzArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveOrientation(device deviceArg: Device_, timestamp timestampArg: Int64, roll rollArg: Double, pitch pitchArg: Double, yaw yawArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveOrientation"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, rollArg, pitchArg, yawArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveBodyPosition(device deviceArg: Device_, timestamp timestampArg: Int64, bodyPosition bodyPositionArg: BodyPosition_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBodyPosition"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, bodyPositionArg.rawValue] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveActivity(device deviceArg: Device_, timestamp timestampArg: Int64, activity activityArg: ActivityType_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveActivity"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, activityArg.rawValue] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveSteps(device deviceArg: Device_, timestamp timestampArg: Int64, steps stepsArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSteps"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, stepsArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveHeartRate(device deviceArg: Device_, timestamp timestampArg: Int64, heartRate heartRateArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveHeartRate"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, heartRateArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveRr(device deviceArg: Device_, timestamp timestampArg: Int64, rr rrArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRr"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, rrArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didDetectExercise(device deviceArg: Device_, exercise exerciseArg: Exercise_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectExercise"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, exerciseArg.rawValue] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveSoundVolume(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundVolume"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveSoundFeatures(device deviceArg: Device_, timestamp timestampArg: Int64, values valuesArg: [Double], completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundFeatures"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valuesArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePressure(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePressure"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func pressureWearStateDidChange(device deviceArg: Device_, wearState wearStateArg: WearState_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.pressureWearStateDidChange"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, wearStateArg.rawValue] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveSignalQuality(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSignalQuality"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didDetectUserEvent(device deviceArg: Device_, timestamp timestampArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectUserEvent"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveCommand(device deviceArg: Device_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveCommand"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveError(error errorArg: String, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveError"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([errorArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveMessage(device deviceArg: Device_, process processArg: String, message messageArg: String, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMessage"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, processArg, messageArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func syncStateDidChange(device deviceArg: Device_, state stateArg: SyncState_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.syncStateDidChange"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, stateArg.rawValue] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceiveUnsynchronizedSize(device deviceArg: Device_, unsynchronizedSize unsynchronizedSizeArg: Int64, syncBytesPerSecond syncBytesPerSecondArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveUnsynchronizedSize"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, unsynchronizedSizeArg, syncBytesPerSecondArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastECG(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastECG"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastRespiration(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespiration"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastSkinTemperature(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSkinTemperature"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastHeartRate(device deviceArg: Device_, timestamp timestampArg: Int64, heartRate heartRateArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastHeartRate"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, heartRateArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastRr(device deviceArg: Device_, timestamp timestampArg: Int64, rr rrArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRr"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, rrArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastRespirationRate(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespirationRate"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastActivity(device deviceArg: Device_, timestamp timestampArg: Int64, activity activityArg: ActivityType_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastActivity"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, activityArg.rawValue] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastSteps(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSteps"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastSoundVolume(device deviceArg: Device_, timestamp timestampArg: Int64, soundVolume soundVolumeArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundVolume"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, soundVolumeArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastSoundFeatures(device deviceArg: Device_, timestamp timestampArg: Int64, values valuesArg: [Double], completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundFeatures"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valuesArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastAccelerometer(device deviceArg: Device_, timestamp timestampArg: Int64, ax axArg: Double, ay ayArg: Double, az azArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastAccelerometer"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, axArg, ayArg, azArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastGyroscope(device deviceArg: Device_, timestamp timestampArg: Int64, qx qxArg: Double, qy qyArg: Double, qz qzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastGyroscope"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, qxArg, qyArg, qzArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastMagnetometer(device deviceArg: Device_, timestamp timestampArg: Int64, mx mxArg: Double, my myArg: Double, mz mzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastMagnetometer"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, mxArg, myArg, mzArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastQuaternion(device deviceArg: Device_, timestamp timestampArg: Int64, qw qwArg: Double, qx qxArg: Double, qy qyArg: Double, qz qzArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastQuaternion"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, qwArg, qxArg, qyArg, qzArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastOrientation(device deviceArg: Device_, timestamp timestampArg: Int64, roll rollArg: Double, pitch pitchArg: Double, yaw yawArg: Double, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastOrientation"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, rollArg, pitchArg, yawArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastBodyPosition(device deviceArg: Device_, timestamp timestampArg: Int64, bodyPosition bodyPositionArg: BodyPosition_, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastBodyPosition"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, bodyPositionArg.rawValue] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastPressure(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastPressure"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didDetectPastUserEvent(device deviceArg: Device_, timestamp timestampArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectPastUserEvent"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
  func didReceivePastSignalQuality(device deviceArg: Device_, timestamp timestampArg: Int64, value valueArg: Int64, completion: @escaping (Result<Void, FlutterError>) -> Void) {
    let channelName: String = "dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSignalQuality"
    let channel = FlutterBasicMessageChannel(name: channelName, binaryMessenger: binaryMessenger, codec: codec)
    channel.sendMessage([deviceArg, timestampArg, valueArg] as [Any?]) { response in
      guard let listResponse = response as? [Any?] else {
        completion(.failure(createConnectionError(withChannelName: channelName)))
        return
      }
      if listResponse.count > 1 {
        let code: String = listResponse[0] as! String
        let message: String? = nilOrValue(listResponse[1])
        let details: String? = nilOrValue(listResponse[2])
        completion(.failure(FlutterError(code: code, message: message, details: details)))
      } else {
        completion(.success(Void()))
      }
    }
  }
}
