// Autogenerated from Pigeon (v17.1.3), do not edit directly.
// See also: https://pub.dev/packages/pigeon
// ignore_for_file: public_member_api_docs, non_constant_identifier_names, avoid_as, unused_import, unnecessary_parenthesis, prefer_null_aware_operators, omit_local_variable_types, unused_shown_name, unnecessary_import, no_leading_underscores_for_local_identifiers

import 'dart:async';
import 'dart:typed_data' show Float64List, Int32List, Int64List, Uint8List;

import 'package:flutter/foundation.dart' show ReadBuffer, WriteBuffer;
import 'package:flutter/services.dart';

PlatformException _createConnectionError(String channelName) {
  return PlatformException(
    code: 'channel-error',
    message: 'Unable to establish connection on channel: "$channelName".',
  );
}

List<Object?> wrapResponse(
    {Object? result, PlatformException? error, bool empty = false}) {
  if (empty) {
    return <Object?>[];
  }
  if (error == null) {
    return <Object?>[result];
  }
  return <Object?>[error.code, error.message, error.details];
}

enum SyncState_ {
  Start,
  End,
  Stop,
  Empty,
}

enum WearState_ {
  PlacedProperly,
  PlacedUpsideDown,
  Loose,
  Detached,
  Unknown,
}

enum EcgFiltrationMethod_ {
  normal,
  aggressive,
}

enum DisconnectReason_ {
  Timeout,
  DeviceDisconnected,
  AppDisconnected,
  SdkOutdated,
  UnknownError,
}

enum DataType_ {
  ECG,
  RESPIRATION,
  SKIN_TEMPERATURE,
  MOTION,
  RESERVED_0,
  ACTIVITY,
  ORIENTATION,
  STEPS,
  HEART_RATE,
  RESERVED_1,
  SOUND_VOLUME,
  RR,
  PRESSURE,
  SOUND_FEATURES,
  RESPIRATION_RATE,
  BODY_POSITION,
}

enum ScanMode_ {
  lowPower,
  aggressive,
}

enum BodyPosition_ {
  undefined,
  prone,
  supine,
  leftSide,
  rightSide,
}

enum Exercise_ {
  PushUp,
  Jump,
  SitUp,
  Burpee,
  PullUp,
  Squat,
  PlankStart,
  PlankEnd,
}

enum ActivityType_ {
  Unspecific,
  Automotive,
  Walking,
  Running,
  Cycling,
  Still,
}

class FlutterDataType_ {
  FlutterDataType_({
    this.signal,
  });

  DataType_? signal;

  Object encode() {
    return <Object?>[
      signal?.index,
    ];
  }

  static FlutterDataType_ decode(Object result) {
    result as List<Object?>;
    return FlutterDataType_(
      signal: result[0] != null ? DataType_.values[result[0]! as int] : null,
    );
  }
}

class Device_ {
  Device_({
    this.firmwareRevision,
    this.hardwareRevision,
    this.serialNumber,
    this.name,
    this.manufacturerName,
    required this.address,
  });

  String? firmwareRevision;

  String? hardwareRevision;

  String? serialNumber;

  String? name;

  String? manufacturerName;

  String address;

  Object encode() {
    return <Object?>[
      firmwareRevision,
      hardwareRevision,
      serialNumber,
      name,
      manufacturerName,
      address,
    ];
  }

  static Device_ decode(Object result) {
    result as List<Object?>;
    return Device_(
      firmwareRevision: result[0] as String?,
      hardwareRevision: result[1] as String?,
      serialNumber: result[2] as String?,
      name: result[3] as String?,
      manufacturerName: result[4] as String?,
      address: result[5]! as String,
    );
  }
}

class _AidlabManager_Codec extends StandardMessageCodec {
  const _AidlabManager_Codec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is Device_) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is FlutterDataType_) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return Device_.decode(readValue(buffer)!);
      case 129:
        return FlutterDataType_.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

class AidlabManager_ {
  /// Constructor for [AidlabManager_].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  AidlabManager_({BinaryMessenger? binaryMessenger})
      : __pigeon_binaryMessenger = binaryMessenger;
  final BinaryMessenger? __pigeon_binaryMessenger;

  static const MessageCodec<Object?> pigeonChannelCodec =
      _AidlabManager_Codec();

  Future<void> scan(ScanMode_ mode) async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.AidlabManager_.scan';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(<Object?>[mode.index]) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> stopScan() async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.AidlabManager_.stopScan';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(null) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> connect(Device_ device) async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.AidlabManager_.connect';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(<Object?>[device]) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> collect(Device_ device, List<FlutterDataType_?> dataTypes,
      List<FlutterDataType_?> dataTypesToStore) async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.AidlabManager_.collect';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList = await __pigeon_channel
        .send(<Object?>[device, dataTypes, dataTypesToStore]) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }

  Future<void> disconnect(Device_ device) async {
    const String __pigeon_channelName =
        'dev.flutter.pigeon.aidlab_sdk.AidlabManager_.disconnect';
    final BasicMessageChannel<Object?> __pigeon_channel =
        BasicMessageChannel<Object?>(
      __pigeon_channelName,
      pigeonChannelCodec,
      binaryMessenger: __pigeon_binaryMessenger,
    );
    final List<Object?>? __pigeon_replyList =
        await __pigeon_channel.send(<Object?>[device]) as List<Object?>?;
    if (__pigeon_replyList == null) {
      throw _createConnectionError(__pigeon_channelName);
    } else if (__pigeon_replyList.length > 1) {
      throw PlatformException(
        code: __pigeon_replyList[0]! as String,
        message: __pigeon_replyList[1] as String?,
        details: __pigeon_replyList[2],
      );
    } else {
      return;
    }
  }
}

class _AidlabManagerDelegate_Codec extends StandardMessageCodec {
  const _AidlabManagerDelegate_Codec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is Device_) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return Device_.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class AidlabManagerDelegate_ {
  static const MessageCodec<Object?> pigeonChannelCodec =
      _AidlabManagerDelegate_Codec();

  void onBluetoothStarted();

  void onDeviceScanStarted();

  void onDeviceScanStopped();

  void onScanFailed(int errorCode);

  void didDiscover(Device_ device, int rssi);

  static void setup(AidlabManagerDelegate_? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onBluetoothStarted',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          try {
            api.onBluetoothStarted();
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onDeviceScanStarted',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          try {
            api.onDeviceScanStarted();
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onDeviceScanStopped',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          try {
            api.onDeviceScanStopped();
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onScanFailed',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onScanFailed was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_errorCode = (args[0] as int?);
          assert(arg_errorCode != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.onScanFailed was null, expected non-null int.');
          try {
            api.onScanFailed(arg_errorCode!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.didDiscover',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.didDiscover was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.didDiscover was null, expected non-null Device_.');
          final int? arg_rssi = (args[1] as int?);
          assert(arg_rssi != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.AidlabManagerDelegate_.didDiscover was null, expected non-null int.');
          try {
            api.didDiscover(arg_device!, arg_rssi!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
  }
}

class _DeviceDelegate_Codec extends StandardMessageCodec {
  const _DeviceDelegate_Codec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is Device_) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is Device_) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return Device_.decode(readValue(buffer)!);
      case 129:
        return Device_.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class DeviceDelegate_ {
  static const MessageCodec<Object?> pigeonChannelCodec =
      _DeviceDelegate_Codec();

  void didConnect(Device_ device);

  void didDisconnect(Device_? device, DisconnectReason_ reason);

  void wearStateDidChange(Device_ device, WearState_ wearState);

  void didReceiveECG(Device_ device, int timestamp, double value);

  void didReceiveRespiration(Device_ device, int timestamp, double value);

  void didReceiveRespirationRate(Device_ device, int timestamp, int value);

  void didReceiveBatteryLevel(Device_ device, int stateOfCharge);

  void didReceiveSkinTemperature(Device_ device, int timestamp, double value);

  void didReceiveAccelerometer(
      Device_ device, int timestamp, double ax, double ay, double az);

  void didReceiveGyroscope(
      Device_ device, int timestamp, double qx, double qy, double qz);

  void didReceiveMagnetometer(
      Device_ device, int timestamp, double mx, double my, double mz);

  void didReceiveQuaternion(Device_ device, int timestamp, double qw, double qx,
      double qy, double qz);

  void didReceiveOrientation(
      Device_ device, int timestamp, double roll, double pitch, double yaw);

  void didReceiveBodyPosition(
      Device_ device, int timestamp, BodyPosition_ bodyPosition);

  void didReceiveActivity(
      Device_ device, int timestamp, ActivityType_ activity);

  void didReceiveSteps(Device_ device, int timestamp, int steps);

  void didReceiveHeartRate(Device_ device, int timestamp, int heartRate);

  void didReceiveRr(Device_ device, int timestamp, int rr);

  void didDetectExercise(Device_ device, Exercise_ exercise);

  void didReceiveSoundVolume(Device_ device, int timestamp, int value);

  void didReceiveSoundFeatures(
      Device_ device, int timestamp, List<double?> values);

  void didReceivePressure(Device_ device, int timestamp, int value);

  void pressureWearStateDidChange(Device_ device, WearState_ wearState);

  void didReceiveSignalQuality(Device_ device, int timestamp, int value);

  void didDetectUserEvent(Device_ device, int timestamp);

  void didReceiveCommand(Device_ device);

  void didReceiveError(String error);

  void didReceiveMessage(Device_ device, String process, String message);

  void syncStateDidChange(Device_ device, SyncState_ state);

  void didReceiveUnsynchronizedSize(
      Device_ device, int unsynchronizedSize, double syncBytesPerSecond);

  void didReceivePastECG(Device_ device, int timestamp, double value);

  void didReceivePastRespiration(Device_ device, int timestamp, double value);

  void didReceivePastSkinTemperature(
      Device_ device, int timestamp, double value);

  void didReceivePastHeartRate(Device_ device, int timestamp, int heartRate);

  void didReceivePastRr(Device_ device, int timestamp, int rr);

  void didReceivePastRespirationRate(Device_ device, int timestamp, int value);

  void didReceivePastActivity(
      Device_ device, int timestamp, ActivityType_ activity);

  void didReceivePastSteps(Device_ device, int timestamp, int value);

  void didReceivePastSoundVolume(
      Device_ device, int timestamp, int soundVolume);

  void didReceivePastSoundFeatures(
      Device_ device, int timestamp, List<double?> values);

  void didReceivePastAccelerometer(
      Device_ device, int timestamp, double ax, double ay, double az);

  void didReceivePastGyroscope(
      Device_ device, int timestamp, double qx, double qy, double qz);

  void didReceivePastMagnetometer(
      Device_ device, int timestamp, double mx, double my, double mz);

  void didReceivePastQuaternion(Device_ device, int timestamp, double qw,
      double qx, double qy, double qz);

  void didReceivePastOrientation(
      Device_ device, int timestamp, double roll, double pitch, double yaw);

  void didReceivePastBodyPosition(
      Device_ device, int timestamp, BodyPosition_ bodyPosition);

  void didReceivePastPressure(Device_ device, int timestamp, int value);

  void didDetectPastUserEvent(Device_ device, int timestamp);

  void didReceivePastSignalQuality(Device_ device, int timestamp, int value);

  static void setup(DeviceDelegate_? api, {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didConnect',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didConnect was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didConnect was null, expected non-null Device_.');
          try {
            api.didConnect(arg_device!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDisconnect',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDisconnect was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          final DisconnectReason_? arg_reason = args[1] == null
              ? null
              : DisconnectReason_.values[args[1]! as int];
          assert(arg_reason != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDisconnect was null, expected non-null DisconnectReason_.');
          try {
            api.didDisconnect(arg_device, arg_reason!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.wearStateDidChange',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.wearStateDidChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.wearStateDidChange was null, expected non-null Device_.');
          final WearState_? arg_wearState =
              args[1] == null ? null : WearState_.values[args[1]! as int];
          assert(arg_wearState != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.wearStateDidChange was null, expected non-null WearState_.');
          try {
            api.wearStateDidChange(arg_device!, arg_wearState!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveECG',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveECG was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveECG was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveECG was null, expected non-null int.');
          final double? arg_value = (args[2] as double?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveECG was null, expected non-null double.');
          try {
            api.didReceiveECG(arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespiration',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespiration was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespiration was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespiration was null, expected non-null int.');
          final double? arg_value = (args[2] as double?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespiration was null, expected non-null double.');
          try {
            api.didReceiveRespiration(arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespirationRate',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespirationRate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespirationRate was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespirationRate was null, expected non-null int.');
          final int? arg_value = (args[2] as int?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRespirationRate was null, expected non-null int.');
          try {
            api.didReceiveRespirationRate(
                arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBatteryLevel',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBatteryLevel was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBatteryLevel was null, expected non-null Device_.');
          final int? arg_stateOfCharge = (args[1] as int?);
          assert(arg_stateOfCharge != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBatteryLevel was null, expected non-null int.');
          try {
            api.didReceiveBatteryLevel(arg_device!, arg_stateOfCharge!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSkinTemperature',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSkinTemperature was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSkinTemperature was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSkinTemperature was null, expected non-null int.');
          final double? arg_value = (args[2] as double?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSkinTemperature was null, expected non-null double.');
          try {
            api.didReceiveSkinTemperature(
                arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveAccelerometer',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveAccelerometer was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveAccelerometer was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveAccelerometer was null, expected non-null int.');
          final double? arg_ax = (args[2] as double?);
          assert(arg_ax != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveAccelerometer was null, expected non-null double.');
          final double? arg_ay = (args[3] as double?);
          assert(arg_ay != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveAccelerometer was null, expected non-null double.');
          final double? arg_az = (args[4] as double?);
          assert(arg_az != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveAccelerometer was null, expected non-null double.');
          try {
            api.didReceiveAccelerometer(
                arg_device!, arg_timestamp!, arg_ax!, arg_ay!, arg_az!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveGyroscope',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveGyroscope was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveGyroscope was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveGyroscope was null, expected non-null int.');
          final double? arg_qx = (args[2] as double?);
          assert(arg_qx != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveGyroscope was null, expected non-null double.');
          final double? arg_qy = (args[3] as double?);
          assert(arg_qy != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveGyroscope was null, expected non-null double.');
          final double? arg_qz = (args[4] as double?);
          assert(arg_qz != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveGyroscope was null, expected non-null double.');
          try {
            api.didReceiveGyroscope(
                arg_device!, arg_timestamp!, arg_qx!, arg_qy!, arg_qz!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMagnetometer',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMagnetometer was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMagnetometer was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMagnetometer was null, expected non-null int.');
          final double? arg_mx = (args[2] as double?);
          assert(arg_mx != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMagnetometer was null, expected non-null double.');
          final double? arg_my = (args[3] as double?);
          assert(arg_my != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMagnetometer was null, expected non-null double.');
          final double? arg_mz = (args[4] as double?);
          assert(arg_mz != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMagnetometer was null, expected non-null double.');
          try {
            api.didReceiveMagnetometer(
                arg_device!, arg_timestamp!, arg_mx!, arg_my!, arg_mz!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveQuaternion',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveQuaternion was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveQuaternion was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveQuaternion was null, expected non-null int.');
          final double? arg_qw = (args[2] as double?);
          assert(arg_qw != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveQuaternion was null, expected non-null double.');
          final double? arg_qx = (args[3] as double?);
          assert(arg_qx != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveQuaternion was null, expected non-null double.');
          final double? arg_qy = (args[4] as double?);
          assert(arg_qy != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveQuaternion was null, expected non-null double.');
          final double? arg_qz = (args[5] as double?);
          assert(arg_qz != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveQuaternion was null, expected non-null double.');
          try {
            api.didReceiveQuaternion(arg_device!, arg_timestamp!, arg_qw!,
                arg_qx!, arg_qy!, arg_qz!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveOrientation',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveOrientation was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveOrientation was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveOrientation was null, expected non-null int.');
          final double? arg_roll = (args[2] as double?);
          assert(arg_roll != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveOrientation was null, expected non-null double.');
          final double? arg_pitch = (args[3] as double?);
          assert(arg_pitch != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveOrientation was null, expected non-null double.');
          final double? arg_yaw = (args[4] as double?);
          assert(arg_yaw != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveOrientation was null, expected non-null double.');
          try {
            api.didReceiveOrientation(
                arg_device!, arg_timestamp!, arg_roll!, arg_pitch!, arg_yaw!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBodyPosition',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBodyPosition was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBodyPosition was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBodyPosition was null, expected non-null int.');
          final BodyPosition_? arg_bodyPosition =
              args[2] == null ? null : BodyPosition_.values[args[2]! as int];
          assert(arg_bodyPosition != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveBodyPosition was null, expected non-null BodyPosition_.');
          try {
            api.didReceiveBodyPosition(
                arg_device!, arg_timestamp!, arg_bodyPosition!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveActivity',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveActivity was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveActivity was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveActivity was null, expected non-null int.');
          final ActivityType_? arg_activity =
              args[2] == null ? null : ActivityType_.values[args[2]! as int];
          assert(arg_activity != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveActivity was null, expected non-null ActivityType_.');
          try {
            api.didReceiveActivity(arg_device!, arg_timestamp!, arg_activity!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSteps',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSteps was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSteps was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSteps was null, expected non-null int.');
          final int? arg_steps = (args[2] as int?);
          assert(arg_steps != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSteps was null, expected non-null int.');
          try {
            api.didReceiveSteps(arg_device!, arg_timestamp!, arg_steps!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveHeartRate',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveHeartRate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveHeartRate was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveHeartRate was null, expected non-null int.');
          final int? arg_heartRate = (args[2] as int?);
          assert(arg_heartRate != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveHeartRate was null, expected non-null int.');
          try {
            api.didReceiveHeartRate(
                arg_device!, arg_timestamp!, arg_heartRate!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRr',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRr was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRr was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRr was null, expected non-null int.');
          final int? arg_rr = (args[2] as int?);
          assert(arg_rr != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveRr was null, expected non-null int.');
          try {
            api.didReceiveRr(arg_device!, arg_timestamp!, arg_rr!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectExercise',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectExercise was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectExercise was null, expected non-null Device_.');
          final Exercise_? arg_exercise =
              args[1] == null ? null : Exercise_.values[args[1]! as int];
          assert(arg_exercise != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectExercise was null, expected non-null Exercise_.');
          try {
            api.didDetectExercise(arg_device!, arg_exercise!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundVolume',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundVolume was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundVolume was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundVolume was null, expected non-null int.');
          final int? arg_value = (args[2] as int?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundVolume was null, expected non-null int.');
          try {
            api.didReceiveSoundVolume(arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundFeatures',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundFeatures was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundFeatures was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundFeatures was null, expected non-null int.');
          final List<double?>? arg_values =
              (args[2] as List<Object?>?)?.cast<double?>();
          assert(arg_values != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSoundFeatures was null, expected non-null List<double?>.');
          try {
            api.didReceiveSoundFeatures(
                arg_device!, arg_timestamp!, arg_values!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePressure',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePressure was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePressure was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePressure was null, expected non-null int.');
          final int? arg_value = (args[2] as int?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePressure was null, expected non-null int.');
          try {
            api.didReceivePressure(arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.pressureWearStateDidChange',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.pressureWearStateDidChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.pressureWearStateDidChange was null, expected non-null Device_.');
          final WearState_? arg_wearState =
              args[1] == null ? null : WearState_.values[args[1]! as int];
          assert(arg_wearState != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.pressureWearStateDidChange was null, expected non-null WearState_.');
          try {
            api.pressureWearStateDidChange(arg_device!, arg_wearState!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSignalQuality',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSignalQuality was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSignalQuality was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSignalQuality was null, expected non-null int.');
          final int? arg_value = (args[2] as int?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveSignalQuality was null, expected non-null int.');
          try {
            api.didReceiveSignalQuality(
                arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectUserEvent',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectUserEvent was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectUserEvent was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectUserEvent was null, expected non-null int.');
          try {
            api.didDetectUserEvent(arg_device!, arg_timestamp!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveCommand',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveCommand was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveCommand was null, expected non-null Device_.');
          try {
            api.didReceiveCommand(arg_device!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveError',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveError was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_error = (args[0] as String?);
          assert(arg_error != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveError was null, expected non-null String.');
          try {
            api.didReceiveError(arg_error!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMessage',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMessage was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMessage was null, expected non-null Device_.');
          final String? arg_process = (args[1] as String?);
          assert(arg_process != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMessage was null, expected non-null String.');
          final String? arg_message = (args[2] as String?);
          assert(arg_message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveMessage was null, expected non-null String.');
          try {
            api.didReceiveMessage(arg_device!, arg_process!, arg_message!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.syncStateDidChange',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.syncStateDidChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.syncStateDidChange was null, expected non-null Device_.');
          final SyncState_? arg_state =
              args[1] == null ? null : SyncState_.values[args[1]! as int];
          assert(arg_state != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.syncStateDidChange was null, expected non-null SyncState_.');
          try {
            api.syncStateDidChange(arg_device!, arg_state!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveUnsynchronizedSize',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveUnsynchronizedSize was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveUnsynchronizedSize was null, expected non-null Device_.');
          final int? arg_unsynchronizedSize = (args[1] as int?);
          assert(arg_unsynchronizedSize != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveUnsynchronizedSize was null, expected non-null int.');
          final double? arg_syncBytesPerSecond = (args[2] as double?);
          assert(arg_syncBytesPerSecond != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceiveUnsynchronizedSize was null, expected non-null double.');
          try {
            api.didReceiveUnsynchronizedSize(
                arg_device!, arg_unsynchronizedSize!, arg_syncBytesPerSecond!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastECG',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastECG was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastECG was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastECG was null, expected non-null int.');
          final double? arg_value = (args[2] as double?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastECG was null, expected non-null double.');
          try {
            api.didReceivePastECG(arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespiration',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespiration was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespiration was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespiration was null, expected non-null int.');
          final double? arg_value = (args[2] as double?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespiration was null, expected non-null double.');
          try {
            api.didReceivePastRespiration(
                arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSkinTemperature',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSkinTemperature was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSkinTemperature was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSkinTemperature was null, expected non-null int.');
          final double? arg_value = (args[2] as double?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSkinTemperature was null, expected non-null double.');
          try {
            api.didReceivePastSkinTemperature(
                arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastHeartRate',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastHeartRate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastHeartRate was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastHeartRate was null, expected non-null int.');
          final int? arg_heartRate = (args[2] as int?);
          assert(arg_heartRate != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastHeartRate was null, expected non-null int.');
          try {
            api.didReceivePastHeartRate(
                arg_device!, arg_timestamp!, arg_heartRate!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel =
          BasicMessageChannel<Object?>(
              'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRr',
              pigeonChannelCodec,
              binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRr was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRr was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRr was null, expected non-null int.');
          final int? arg_rr = (args[2] as int?);
          assert(arg_rr != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRr was null, expected non-null int.');
          try {
            api.didReceivePastRr(arg_device!, arg_timestamp!, arg_rr!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespirationRate',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespirationRate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespirationRate was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespirationRate was null, expected non-null int.');
          final int? arg_value = (args[2] as int?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastRespirationRate was null, expected non-null int.');
          try {
            api.didReceivePastRespirationRate(
                arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastActivity',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastActivity was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastActivity was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastActivity was null, expected non-null int.');
          final ActivityType_? arg_activity =
              args[2] == null ? null : ActivityType_.values[args[2]! as int];
          assert(arg_activity != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastActivity was null, expected non-null ActivityType_.');
          try {
            api.didReceivePastActivity(
                arg_device!, arg_timestamp!, arg_activity!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSteps',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSteps was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSteps was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSteps was null, expected non-null int.');
          final int? arg_value = (args[2] as int?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSteps was null, expected non-null int.');
          try {
            api.didReceivePastSteps(arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundVolume',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundVolume was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundVolume was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundVolume was null, expected non-null int.');
          final int? arg_soundVolume = (args[2] as int?);
          assert(arg_soundVolume != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundVolume was null, expected non-null int.');
          try {
            api.didReceivePastSoundVolume(
                arg_device!, arg_timestamp!, arg_soundVolume!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundFeatures',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundFeatures was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundFeatures was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundFeatures was null, expected non-null int.');
          final List<double?>? arg_values =
              (args[2] as List<Object?>?)?.cast<double?>();
          assert(arg_values != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSoundFeatures was null, expected non-null List<double?>.');
          try {
            api.didReceivePastSoundFeatures(
                arg_device!, arg_timestamp!, arg_values!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastAccelerometer',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastAccelerometer was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastAccelerometer was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastAccelerometer was null, expected non-null int.');
          final double? arg_ax = (args[2] as double?);
          assert(arg_ax != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastAccelerometer was null, expected non-null double.');
          final double? arg_ay = (args[3] as double?);
          assert(arg_ay != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastAccelerometer was null, expected non-null double.');
          final double? arg_az = (args[4] as double?);
          assert(arg_az != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastAccelerometer was null, expected non-null double.');
          try {
            api.didReceivePastAccelerometer(
                arg_device!, arg_timestamp!, arg_ax!, arg_ay!, arg_az!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastGyroscope',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastGyroscope was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastGyroscope was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastGyroscope was null, expected non-null int.');
          final double? arg_qx = (args[2] as double?);
          assert(arg_qx != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastGyroscope was null, expected non-null double.');
          final double? arg_qy = (args[3] as double?);
          assert(arg_qy != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastGyroscope was null, expected non-null double.');
          final double? arg_qz = (args[4] as double?);
          assert(arg_qz != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastGyroscope was null, expected non-null double.');
          try {
            api.didReceivePastGyroscope(
                arg_device!, arg_timestamp!, arg_qx!, arg_qy!, arg_qz!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastMagnetometer',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastMagnetometer was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastMagnetometer was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastMagnetometer was null, expected non-null int.');
          final double? arg_mx = (args[2] as double?);
          assert(arg_mx != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastMagnetometer was null, expected non-null double.');
          final double? arg_my = (args[3] as double?);
          assert(arg_my != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastMagnetometer was null, expected non-null double.');
          final double? arg_mz = (args[4] as double?);
          assert(arg_mz != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastMagnetometer was null, expected non-null double.');
          try {
            api.didReceivePastMagnetometer(
                arg_device!, arg_timestamp!, arg_mx!, arg_my!, arg_mz!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastQuaternion',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastQuaternion was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastQuaternion was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastQuaternion was null, expected non-null int.');
          final double? arg_qw = (args[2] as double?);
          assert(arg_qw != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastQuaternion was null, expected non-null double.');
          final double? arg_qx = (args[3] as double?);
          assert(arg_qx != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastQuaternion was null, expected non-null double.');
          final double? arg_qy = (args[4] as double?);
          assert(arg_qy != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastQuaternion was null, expected non-null double.');
          final double? arg_qz = (args[5] as double?);
          assert(arg_qz != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastQuaternion was null, expected non-null double.');
          try {
            api.didReceivePastQuaternion(arg_device!, arg_timestamp!, arg_qw!,
                arg_qx!, arg_qy!, arg_qz!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastOrientation',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastOrientation was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastOrientation was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastOrientation was null, expected non-null int.');
          final double? arg_roll = (args[2] as double?);
          assert(arg_roll != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastOrientation was null, expected non-null double.');
          final double? arg_pitch = (args[3] as double?);
          assert(arg_pitch != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastOrientation was null, expected non-null double.');
          final double? arg_yaw = (args[4] as double?);
          assert(arg_yaw != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastOrientation was null, expected non-null double.');
          try {
            api.didReceivePastOrientation(
                arg_device!, arg_timestamp!, arg_roll!, arg_pitch!, arg_yaw!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastBodyPosition',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastBodyPosition was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastBodyPosition was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastBodyPosition was null, expected non-null int.');
          final BodyPosition_? arg_bodyPosition =
              args[2] == null ? null : BodyPosition_.values[args[2]! as int];
          assert(arg_bodyPosition != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastBodyPosition was null, expected non-null BodyPosition_.');
          try {
            api.didReceivePastBodyPosition(
                arg_device!, arg_timestamp!, arg_bodyPosition!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastPressure',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastPressure was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastPressure was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastPressure was null, expected non-null int.');
          final int? arg_value = (args[2] as int?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastPressure was null, expected non-null int.');
          try {
            api.didReceivePastPressure(arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectPastUserEvent',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectPastUserEvent was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectPastUserEvent was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didDetectPastUserEvent was null, expected non-null int.');
          try {
            api.didDetectPastUserEvent(arg_device!, arg_timestamp!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
    {
      final BasicMessageChannel<Object?> __pigeon_channel = BasicMessageChannel<
              Object?>(
          'dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSignalQuality',
          pigeonChannelCodec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        __pigeon_channel.setMessageHandler(null);
      } else {
        __pigeon_channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSignalQuality was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Device_? arg_device = (args[0] as Device_?);
          assert(arg_device != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSignalQuality was null, expected non-null Device_.');
          final int? arg_timestamp = (args[1] as int?);
          assert(arg_timestamp != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSignalQuality was null, expected non-null int.');
          final int? arg_value = (args[2] as int?);
          assert(arg_value != null,
              'Argument for dev.flutter.pigeon.aidlab_sdk.DeviceDelegate_.didReceivePastSignalQuality was null, expected non-null int.');
          try {
            api.didReceivePastSignalQuality(
                arg_device!, arg_timestamp!, arg_value!);
            return wrapResponse(empty: true);
          } on PlatformException catch (e) {
            return wrapResponse(error: e);
          } catch (e) {
            return wrapResponse(
                error: PlatformException(code: 'error', message: e.toString()));
          }
        });
      }
    }
  }
}
